Index: /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm
===================================================================
--- /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm	(revision 50158)
+++ /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm	(revision 50159)
@@ -1564,38 +1594,38 @@
     mov cx, ax                                ; 89 c1
     mov ax, word [bp+004h]                    ; 8b 46 04
-    call 0185ah                               ; e8 19 fe
-    jmp near 01b1ah                           ; e9 d6 00
+    call 0186fh                               ; e8 19 fe
+    jmp near 01b2fh                           ; e9 d6 00
     cmp dl, 075h                              ; 80 fa 75
-    jne short 01a4bh                          ; 75 02
-    jmp short 01a32h                          ; eb e7
+    jne short 01a60h                          ; 75 02
+    jmp short 01a47h                          ; eb e7
     cmp dl, 078h                              ; 80 fa 78
-    je short 01a57h                           ; 74 07
+    je short 01a6ch                           ; 74 07
     cmp dl, 058h                              ; 80 fa 58
-    jne near 01b1ah                           ; 0f 85 c3 00
+    jne near 01b2fh                           ; 0f 85 c3 00
     test si, si                               ; 85 f6
-    jne short 01a5eh                          ; 75 03
+    jne short 01a73h                          ; 75 03
     mov si, strict word 00008h                ; be 08 00
     cmp dl, 078h                              ; 80 fa 78
-    jne short 01a68h                          ; 75 05
+    jne short 01a7dh                          ; 75 05
     mov di, strict word 00061h                ; bf 61 00
-    jmp short 01a6bh                          ; eb 03
+    jmp short 01a80h                          ; eb 03
     mov di, strict word 00041h                ; bf 41 00
     lea bx, [si-001h]                         ; 8d 5c ff
     test bx, bx                               ; 85 db
-    jl near 01b1ah                            ; 0f 8c a6 00
+    jl near 01b2fh                            ; 0f 8c a6 00
     mov ax, word [bp-00ch]                    ; 8b 46 f4
     mov cx, bx                                ; 89 d9
     sal cx, 002h                              ; c1 e1 02
     mov dx, word [bp-00eh]                    ; 8b 56 f2
-    jcxz 01a87h                               ; e3 06
+    jcxz 01a9ch                               ; e3 06
     shr dx, 1                                 ; d1 ea
     rcr ax, 1                                 ; d1 d8
-    loop 01a81h                               ; e2 fa
+    loop 01a96h                               ; e2 fa
     and ax, strict word 0000fh                ; 25 0f 00
     cmp ax, strict word 00009h                ; 3d 09 00
-    jnbe short 01a96h                         ; 77 07
+    jnbe short 01aabh                         ; 77 07
     mov dx, ax                                ; 89 c2
     add dx, strict byte 00030h                ; 83 c2 30
-    jmp short 01a9dh                          ; eb 07
+    jmp short 01ab2h                          ; eb 07
     mov dx, ax                                ; 89 c2
     sub dx, strict byte 0000ah                ; 83 ea 0a
@@ -1603,30 +1633,30 @@
     xor dh, dh                                ; 30 f6
     mov ax, word [bp+004h]                    ; 8b 46 04
-    call 01760h                               ; e8 bb fc
+    call 01775h                               ; e8 bb fc
     dec bx                                    ; 4b
-    jmp short 01a6eh                          ; eb c6
+    jmp short 01a83h                          ; eb c6
     cmp dl, 064h                              ; 80 fa 64
-    jne short 01acah                          ; 75 1d
+    jne short 01adfh                          ; 75 1d
     test byte [bp-00bh], 080h                 ; f6 46 f5 80
-    je short 01abch                           ; 74 09
+    je short 01ad1h                           ; 74 09
     mov dx, ax                                ; 89 c2
     neg dx                                    ; f7 da
     mov cx, strict word 00001h                ; b9 01 00
-    jmp short 01ac2h                          ; eb 06
+    jmp short 01ad7h                          ; eb 06
     xor cx, cx                                ; 31 c9
     mov bx, si                                ; 89 f3
     mov dx, ax                                ; 89 c2
     mov ax, word [bp+004h]                    ; 8b 46 04
-    call 0179bh                               ; e8 d3 fc
-    jmp short 01b1ah                          ; eb 50
+    call 017b0h                               ; e8 d3 fc
+    jmp short 01b2fh                          ; eb 50
     cmp dl, 073h                              ; 80 fa 73
-    jne short 01adbh                          ; 75 0c
+    jne short 01af0h                          ; 75 0c
     mov cx, ds                                ; 8c d9
     mov bx, ax                                ; 89 c3
     mov ax, word [bp+004h]                    ; 8b 46 04
-    call 018cch                               ; e8 f3 fd
-    jmp short 01b1ah                          ; eb 3f
+    call 018e1h                               ; e8 f3 fd
+    jmp short 01b2fh                          ; eb 3f
     cmp dl, 053h                              ; 80 fa 53
-    jne short 01afeh                          ; 75 1e
+    jne short 01b13h                          ; 75 1e
     mov word [bp-00eh], ax                    ; 89 46 f2
     mov ax, word [bp-010h]                    ; 8b 46 f0
@@ -1638,30 +1668,30 @@
     mov bx, ax                                ; 89 c3
     mov cx, word [bp-00eh]                    ; 8b 4e f2
-    jmp short 01ad3h                          ; eb d5
+    jmp short 01ae8h                          ; eb d5
     cmp dl, 063h                              ; 80 fa 63
-    jne short 01b0fh                          ; 75 0c
+    jne short 01b24h                          ; 75 0c
     movzx dx, byte [bp-00ch]                  ; 0f b6 56 f4
     mov ax, word [bp+004h]                    ; 8b 46 04
-    call 01760h                               ; e8 53 fc
-    jmp short 01b1ah                          ; eb 0b
+    call 01775h                               ; e8 53 fc
+    jmp short 01b2fh                          ; eb 0b
     push 000e6h                               ; 68 e6 00
     push strict byte 00007h                   ; 6a 07
-    call 0190dh                               ; e8 f6 fd
+    call 01922h                               ; e8 f6 fd
     add sp, strict byte 00004h                ; 83 c4 04
     xor cx, cx                                ; 31 c9
-    jmp short 01b26h                          ; eb 08
+    jmp short 01b3bh                          ; eb 08
     xor dh, dh                                ; 30 f6
     mov ax, word [bp+004h]                    ; 8b 46 04
-    call 01760h                               ; e8 3a fc
+    call 01775h                               ; e8 3a fc
     inc word [bp+006h]                        ; ff 46 06
-    jmp near 0193bh                           ; e9 0f fe
+    jmp near 01950h                           ; e9 0f fe
     xor ax, ax                                ; 31 c0
     mov word [bp-012h], ax                    ; 89 46 ee
     mov word [bp-010h], ax                    ; 89 46 f0
     test byte [bp+004h], 001h                 ; f6 46 04 01
-    je short 01b3eh                           ; 74 04
+    je short 01b53h                           ; 74 04
     cli                                       ; fa
     hlt                                       ; f4
-    jmp short 01b3bh                          ; eb fd
+    jmp short 01b50h                          ; eb fd
     lea sp, [bp-00ah]                         ; 8d 66 f6
     pop di                                    ; 5f
@@ -1672,5 +1702,5 @@
     pop bp                                    ; 5d
     retn                                      ; c3
-_ata_init:                                   ; 0xf1b48 LB 0xc4
+_ata_init:                                   ; 0xf1b5d LB 0xc4
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -1678,11 +1708,11 @@
     mov dx, strict word 0000eh                ; ba 0e 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0161ch                               ; e8 c7 fa
+    call 0161ch                               ; e8 b2 fa
     mov si, 00122h                            ; be 22 01
     mov dx, ax                                ; 89 c2
     xor al, al                                ; 30 c0
-    jmp short 01b62h                          ; eb 04
+    jmp short 01b77h                          ; eb 04
     cmp AL, strict byte 004h                  ; 3c 04
-    jnc short 01b86h                          ; 73 24
+    jnc short 01b9bh                          ; 73 24
     movzx bx, al                              ; 0f b6 d8
     imul bx, bx, strict byte 00006h           ; 6b db 06
@@ -1695,9 +1725,9 @@
     db  0feh, 0c0h
     ; inc al                                    ; fe c0
-    jmp short 01b5eh                          ; eb d8
+    jmp short 01b73h                          ; eb d8
     xor al, al                                ; 30 c0
-    jmp short 01b8eh                          ; eb 04
+    jmp short 01ba3h                          ; eb 04
     cmp AL, strict byte 008h                  ; 3c 08
-    jnc short 01bd9h                          ; 73 4b
+    jnc short 01beeh                          ; 73 4b
     movzx bx, al                              ; 0f b6 d8
     imul bx, bx, strict byte 00018h           ; 6b db 18
@@ -1719,9 +1749,9 @@
     db  0feh, 0c0h
     ; inc al                                    ; fe c0
-    jmp short 01b8ah                          ; eb b1
+    jmp short 01b9fh                          ; eb b1
     xor al, al                                ; 30 c0
-    jmp short 01be1h                          ; eb 04
+    jmp short 01bf6h                          ; eb 04
     cmp AL, strict byte 010h                  ; 3c 10
-    jnc short 01bf8h                          ; 73 17
+    jnc short 01c0dh                          ; 73 17
     movzx bx, al                              ; 0f b6 d8
     mov es, dx                                ; 8e c2
@@ -1731,5 +1761,5 @@
     db  0feh, 0c0h
     ; inc al                                    ; fe c0
-    jmp short 01bddh                          ; eb e5
+    jmp short 01bf2h                          ; eb e5
     mov es, dx                                ; 8e c2
     mov byte [es:si+0019eh], 000h             ; 26 c6 84 9e 01 00
@@ -1739,5 +1769,5 @@
     pop bp                                    ; 5d
     retn                                      ; c3
-ata_reset_:                                  ; 0xf1c0c LB 0xde
+ata_reset_:                                  ; 0xf1c21 LB 0xde
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -1752,5 +1782,5 @@
     mov dx, strict word 0000eh                ; ba 0e 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0161ch                               ; e8 fc f9
+    call 0161ch                               ; e8 e7 f9
     mov word [bp-00eh], 00122h                ; c7 46 f2 22 01
     mov di, ax                                ; 89 c7
@@ -1772,5 +1802,5 @@
     dec bx                                    ; 4b
     test bx, bx                               ; 85 db
-    jbe short 01c64h                          ; 76 0c
+    jbe short 01c79h                          ; 76 0c
     mov dx, cx                                ; 89 ca
     add dx, strict byte 00007h                ; 83 c2 07
@@ -1779,5 +1809,5 @@
     ; sub ah, ah                                ; 2a e4
     test AL, strict byte 080h                 ; a8 80
-    je short 01c53h                           ; 74 ef
+    je short 01c68h                           ; 74 ef
     lea dx, [si+006h]                         ; 8d 54 06
     mov AL, strict byte 00ah                  ; b0 0a
@@ -1787,9 +1817,9 @@
     add bx, word [bp-00eh]                    ; 03 5e f2
     cmp byte [es:bx+01eh], 000h               ; 26 80 7f 1e 00
-    je short 01cc6h                           ; 74 4c
+    je short 01cdbh                           ; 74 4c
     cmp byte [bp-00ch], 000h                  ; 80 7e f4 00
-    je short 01c85h                           ; 74 05
+    je short 01c9ah                           ; 74 05
     mov ax, 000b0h                            ; b8 b0 00
-    jmp short 01c88h                          ; eb 03
+    jmp short 01c9dh                          ; eb 03
     mov ax, 000a0h                            ; b8 a0 00
     mov dx, cx                                ; 89 ca
@@ -1809,11 +1839,11 @@
     ; sub ah, ah                                ; 2a e4
     cmp bl, 001h                              ; 80 fb 01
-    jne short 01cc6h                          ; 75 22
+    jne short 01cdbh                          ; 75 22
     cmp al, bl                                ; 38 d8
-    jne short 01cc6h                          ; 75 1e
+    jne short 01cdbh                          ; 75 1e
     mov bx, strict word 0ffffh                ; bb ff ff
     dec bx                                    ; 4b
     test bx, bx                               ; 85 db
-    jbe short 01cc6h                          ; 76 16
+    jbe short 01cdbh                          ; 76 16
     mov dx, cx                                ; 89 ca
     add dx, strict byte 00007h                ; 83 c2 07
@@ -1822,14 +1852,14 @@
     ; sub ah, ah                                ; 2a e4
     test AL, strict byte 080h                 ; a8 80
-    je short 01cc6h                           ; 74 0a
+    je short 01cdbh                           ; 74 0a
     mov ax, strict word 0ffffh                ; b8 ff ff
     dec ax                                    ; 48
     test ax, ax                               ; 85 c0
-    jnbe short 01cbfh                         ; 77 fb
-    jmp short 01cabh                          ; eb e5
+    jnbe short 01cd4h                         ; 77 fb
+    jmp short 01cc0h                          ; eb e5
     mov bx, strict word 00010h                ; bb 10 00
     dec bx                                    ; 4b
     test bx, bx                               ; 85 db
-    jbe short 01cdah                          ; 76 0c
+    jbe short 01cefh                          ; 76 0c
     mov dx, cx                                ; 89 ca
     add dx, strict byte 00007h                ; 83 c2 07
@@ -1838,5 +1868,5 @@
     ; sub ah, ah                                ; 2a e4
     test AL, strict byte 040h                 ; a8 40
-    je short 01cc9h                           ; 74 ef
+    je short 01cdeh                           ; 74 ef
     lea dx, [si+006h]                         ; 8d 54 06
     mov AL, strict byte 008h                  ; b0 08
@@ -1850,5 +1880,5 @@
     pop bp                                    ; 5d
     retn                                      ; c3
-ata_cmd_data_in_:                            ; 0xf1cea LB 0x258
+ata_cmd_data_in_:                            ; 0xf1cff LB 0x258
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -1881,15 +1911,15 @@
     mov word [bp-00ch], ax                    ; 89 46 f4
     test ax, ax                               ; 85 c0
-    jne short 01d52h                          ; 75 14
+    jne short 01d67h                          ; 75 14
     cmp byte [bp-006h], 001h                  ; 80 7e fa 01
-    jne short 01d4bh                          ; 75 07
+    jne short 01d60h                          ; 75 07
     mov word [bp-00ch], 04000h                ; c7 46 f4 00 40
-    jmp short 01d61h                          ; eb 16
+    jmp short 01d76h                          ; eb 16
     mov word [bp-00ch], 08000h                ; c7 46 f4 00 80
-    jmp short 01d61h                          ; eb 0f
+    jmp short 01d76h                          ; eb 0f
     cmp byte [bp-006h], 001h                  ; 80 7e fa 01
-    jne short 01d5eh                          ; 75 06
+    jne short 01d73h                          ; 75 06
     shr word [bp-00ch], 002h                  ; c1 6e f4 02
-    jmp short 01d61h                          ; eb 03
+    jmp short 01d76h                          ; eb 03
     shr word [bp-00ch], 1                     ; d1 6e f4
     lea dx, [bx+007h]                         ; 8d 57 07
@@ -1898,5 +1928,5 @@
     ; sub ah, ah                                ; 2a e4
     test AL, strict byte 080h                 ; a8 80
-    je short 01d7ah                           ; 74 0f
+    je short 01d8fh                           ; 74 0f
     mov dx, word [bp-01ch]                    ; 8b 56 e4
     add dx, strict byte 00006h                ; 83 c2 06
@@ -1904,5 +1934,5 @@
     out DX, AL                                ; ee
     mov dx, strict word 00001h                ; ba 01 00
-    jmp near 01f39h                           ; e9 bf 01
+    jmp near 01f4eh                           ; e9 bf 01
     mov es, [bp-00ah]                         ; 8e 46 f6
     mov ax, word [es:si]                      ; 26 8b 04
@@ -1921,11 +1951,11 @@
     mov ax, word [bp-010h]                    ; 8b 46 f0
     test ax, ax                               ; 85 c0
-    jne short 01e18h                          ; 75 67
+    jne short 01e2dh                          ; 75 67
     mov dx, word [bp-020h]                    ; 8b 56 e0
     add dx, word [bp-014h]                    ; 03 56 ec
     adc ax, word [bp-01eh]                    ; 13 46 e2
     cmp ax, 01000h                            ; 3d 00 10
-    jnbe short 01dc1h                         ; 77 02
-    jne short 01dech                          ; 75 2b
+    jnbe short 01dd6h                         ; 77 02
+    jne short 01e01h                          ; 75 2b
     mov ax, word [bp-01eh]                    ; 8b 46 e2
     xor al, al                                ; 30 c0
@@ -1952,5 +1982,5 @@
     shr word [bp-01eh], 1                     ; d1 6e e2
     rcr word [bp-020h], 1                     ; d1 5e e0
-    loop 01df7h                               ; e2 f8
+    loop 01e0ch                               ; e2 f8
     mov ax, word [bp-020h]                    ; 8b 46 e0
     mov word [bp-012h], ax                    ; 89 46 ee
@@ -1981,7 +2011,7 @@
     out DX, AL                                ; ee
     cmp byte [bp-008h], 000h                  ; 80 7e f8 00
-    je short 01e4eh                           ; 74 05
+    je short 01e63h                           ; 74 05
     mov ax, 000b0h                            ; b8 b0 00
-    jmp short 01e51h                          ; eb 03
+    jmp short 01e66h                          ; eb 03
     mov ax, 000a0h                            ; b8 a0 00
     movzx dx, byte [bp-018h]                  ; 0f b6 56 e8
@@ -1994,11 +2024,11 @@
     mov ax, word [bp-016h]                    ; 8b 46 ea
     cmp ax, 000c4h                            ; 3d c4 00
-    je short 01e6fh                           ; 74 05
+    je short 01e84h                           ; 74 05
     cmp ax, strict word 00029h                ; 3d 29 00
-    jne short 01e7ch                          ; 75 0d
+    jne short 01e91h                          ; 75 0d
     mov ax, word [bp-014h]                    ; 8b 46 ec
     mov word [bp-01ah], ax                    ; 89 46 e6
     mov word [bp-014h], strict word 00001h    ; c7 46 ec 01 00
-    jmp short 01e81h                          ; eb 05
+    jmp short 01e96h                          ; eb 05
     mov word [bp-01ah], strict word 00001h    ; c7 46 e6 01 00
     lea dx, [bx+007h]                         ; 8d 57 07
@@ -2008,7 +2038,7 @@
     mov dl, al                                ; 88 c2
     test AL, strict byte 080h                 ; a8 80
-    jne short 01e81h                          ; 75 f4
+    jne short 01e96h                          ; 75 f4
     test AL, strict byte 001h                 ; a8 01
-    je short 01ea0h                           ; 74 0f
+    je short 01eb5h                           ; 74 0f
     mov dx, word [bp-01ch]                    ; 8b 56 e4
     add dx, strict byte 00006h                ; 83 c2 06
@@ -2016,7 +2046,7 @@
     out DX, AL                                ; ee
     mov dx, strict word 00002h                ; ba 02 00
-    jmp near 01f39h                           ; e9 99 00
+    jmp near 01f4eh                           ; e9 99 00
     test dl, 008h                             ; f6 c2 08
-    jne short 01eb4h                          ; 75 0f
+    jne short 01ec9h                          ; 75 0f
     mov dx, word [bp-01ch]                    ; 8b 56 e4
     add dx, strict byte 00006h                ; 83 c2 06
@@ -2024,8 +2054,8 @@
     out DX, AL                                ; ee
     mov dx, strict word 00003h                ; ba 03 00
-    jmp near 01f39h                           ; e9 85 00
+    jmp near 01f4eh                           ; e9 85 00
     sti                                       ; fb
     cmp di, 0f800h                            ; 81 ff 00 f8
-    jc short 01ec8h                           ; 72 0d
+    jc short 01eddh                           ; 72 0d
     sub di, 00800h                            ; 81 ef 00 08
     mov ax, word [bp-00eh]                    ; 8b 46 f2
@@ -2033,5 +2063,5 @@
     mov word [bp-00eh], ax                    ; 89 46 f2
     cmp byte [bp-006h], 001h                  ; 80 7e fa 01
-    jne short 01edbh                          ; 75 0d
+    jne short 01ef0h                          ; 75 0d
     mov dx, bx                                ; 89 da
     mov cx, word [bp-00ch]                    ; 8b 4e f4
@@ -2039,5 +2069,5 @@
     db  0f3h, 066h, 06dh
     ; rep insd                                  ; f3 66 6d
-    jmp short 01ee5h                          ; eb 0a
+    jmp short 01efah                          ; eb 0a
     mov dx, bx                                ; 89 da
     mov cx, word [bp-00ch]                    ; 8b 4e f4
@@ -2054,10 +2084,10 @@
     mov dl, al                                ; 88 c2
     test AL, strict byte 080h                 ; a8 80
-    jne short 01ef2h                          ; 75 f4
+    jne short 01f07h                          ; 75 f4
     cmp word [bp-014h], strict byte 00000h    ; 83 7e ec 00
-    jne short 01f18h                          ; 75 14
+    jne short 01f2dh                          ; 75 14
     and AL, strict byte 0c9h                  ; 24 c9
     cmp AL, strict byte 040h                  ; 3c 40
-    je short 01f2eh                           ; 74 24
+    je short 01f43h                           ; 74 24
     mov dx, word [bp-01ch]                    ; 8b 56 e4
     add dx, strict byte 00006h                ; 83 c2 06
@@ -2065,9 +2095,9 @@
     out DX, AL                                ; ee
     mov dx, strict word 00004h                ; ba 04 00
-    jmp short 01f39h                          ; eb 21
+    jmp short 01f4eh                          ; eb 21
     mov al, dl                                ; 88 d0
     and AL, strict byte 0c9h                  ; 24 c9
     cmp AL, strict byte 048h                  ; 3c 48
-    je short 01eb5h                           ; 74 95
+    je short 01ecah                           ; 74 95
     mov dx, word [bp-01ch]                    ; 8b 56 e4
     add dx, strict byte 00006h                ; 83 c2 06
@@ -2075,5 +2105,5 @@
     out DX, AL                                ; ee
     mov dx, strict word 00005h                ; ba 05 00
-    jmp short 01f39h                          ; eb 0b
+    jmp short 01f4eh                          ; eb 0b
     mov dx, word [bp-01ch]                    ; 8b 56 e4
     add dx, strict byte 00006h                ; 83 c2 06
@@ -2087,5 +2117,5 @@
     pop bp                                    ; 5d
     retn                                      ; c3
-_ata_detect:                                 ; 0xf1f42 LB 0x617
+_ata_detect:                                 ; 0xf1f57 LB 0x617
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -2095,5 +2125,5 @@
     mov dx, strict word 0000eh                ; ba 0e 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0161ch                               ; e8 c8 f6
+    call 0161ch                               ; e8 b3 f6
     mov word [bp-024h], ax                    ; 89 46 dc
     mov di, 00122h                            ; bf 22 01
@@ -2113,5 +2143,5 @@
     mov byte [bp-006h], al                    ; 88 46 fa
     mov byte [bp-00eh], al                    ; 88 46 f2
-    jmp near 024e4h                           ; e9 48 05
+    jmp near 024f9h                           ; e9 48 05
     mov ax, 000a0h                            ; b8 a0 00
     lea dx, [si+006h]                         ; 8d 54 06
@@ -2145,7 +2175,7 @@
     ; sub ah, ah                                ; 2a e4
     cmp cl, 055h                              ; 80 f9 55
-    jne near 02096h                           ; 0f 85 c0 00
+    jne near 020abh                           ; 0f 85 c0 00
     cmp AL, strict byte 0aah                  ; 3c aa
-    jne near 02096h                           ; 0f 85 ba 00
+    jne near 020abh                           ; 0f 85 ba 00
     movzx ax, byte [bp-00eh]                  ; 0f b6 46 f2
     imul ax, ax, strict byte 00018h           ; 6b c0 18
@@ -2154,9 +2184,9 @@
     mov byte [es:bx+01eh], 001h               ; 26 c6 47 1e 01
     movzx ax, byte [bp-00eh]                  ; 0f b6 46 f2
-    call 01c0ch                               ; e8 18 fc
+    call 01c21h                               ; e8 18 fc
     cmp byte [bp-008h], 000h                  ; 80 7e f8 00
-    je short 01fffh                           ; 74 05
+    je short 02014h                           ; 74 05
     mov ax, 000b0h                            ; b8 b0 00
-    jmp short 02002h                          ; eb 03
+    jmp short 02017h                          ; eb 03
     mov ax, 000a0h                            ; b8 a0 00
     lea dx, [si+006h]                         ; 8d 54 06
@@ -2172,7 +2202,7 @@
     ; sub ah, ah                                ; 2a e4
     cmp bl, 001h                              ; 80 fb 01
-    jne near 02096h                           ; 0f 85 7b 00
+    jne near 020abh                           ; 0f 85 7b 00
     cmp al, bl                                ; 38 d8
-    jne near 02096h                           ; 0f 85 75 00
+    jne near 020abh                           ; 0f 85 75 00
     lea dx, [si+004h]                         ; 8d 54 04
     in AL, DX                                 ; ec
@@ -2192,7 +2222,7 @@
     ; sub ah, ah                                ; 2a e4
     cmp bl, 014h                              ; 80 fb 14
-    jne short 02059h                          ; 75 18
+    jne short 0206eh                          ; 75 18
     cmp cl, 0ebh                              ; 80 f9 eb
-    jne short 02059h                          ; 75 13
+    jne short 0206eh                          ; 75 13
     movzx ax, byte [bp-00eh]                  ; 0f b6 46 f2
     imul ax, ax, strict byte 00018h           ; 6b c0 18
@@ -2200,11 +2230,11 @@
     add bx, ax                                ; 01 c3
     mov byte [es:bx+01eh], 003h               ; 26 c6 47 1e 03
-    jmp short 02096h                          ; eb 3d
+    jmp short 020abh                          ; eb 3d
     test bh, bh                               ; 84 ff
-    jne short 0207bh                          ; 75 1e
+    jne short 02090h                          ; 75 1e
     cmp byte [bp-00ch], 000h                  ; 80 7e f4 00
-    jne short 0207bh                          ; 75 18
+    jne short 02090h                          ; 75 18
     test al, al                               ; 84 c0
-    je short 0207bh                           ; 74 14
+    je short 02090h                           ; 74 14
     movzx bx, byte [bp-00eh]                  ; 0f b6 5e f2
     imul bx, bx, strict byte 00018h           ; 6b db 18
@@ -2212,9 +2242,9 @@
     add bx, word [bp-028h]                    ; 03 5e d8
     mov byte [es:bx+01eh], 002h               ; 26 c6 47 1e 02
-    jmp short 02096h                          ; eb 1b
+    jmp short 020abh                          ; eb 1b
     cmp bh, 0ffh                              ; 80 ff ff
-    jne short 02096h                          ; 75 16
+    jne short 020abh                          ; 75 16
     cmp bh, byte [bp-00ch]                    ; 3a 7e f4
-    jne short 02096h                          ; 75 11
+    jne short 020abh                          ; 75 11
     movzx ax, byte [bp-00eh]                  ; 0f b6 46 f2
     imul ax, ax, strict byte 00018h           ; 6b c0 18
@@ -2233,5 +2263,5 @@
     mov byte [bp-010h], al                    ; 88 46 f0
     cmp AL, strict byte 002h                  ; 3c 02
-    jne near 022bch                           ; 0f 85 03 02
+    jne near 022d1h                           ; 0f 85 03 02
     mov byte [es:si+01fh], 0ffh               ; 26 c6 44 1f ff
     mov byte [es:si+022h], 000h               ; 26 c6 44 22 00
@@ -2246,10 +2276,10 @@
     mov ax, word [bp-028h]                    ; 8b 46 d8
     mov dx, es                                ; 8c c2
-    call 01ceah                               ; e8 03 fc
+    call 01cffh                               ; e8 03 fc
     test ax, ax                               ; 85 c0
-    je short 020f6h                           ; 74 0b
+    je short 0210bh                           ; 74 0b
     push 00104h                               ; 68 04 01
     push strict byte 00007h                   ; 6a 07
-    call 0190dh                               ; e8 1a f8
+    call 01922h                               ; e8 1a f8
     add sp, strict byte 00004h                ; 83 c4 04
     test byte [bp-00260h], 080h               ; f6 86 a0 fd 80
@@ -2274,7 +2304,7 @@
     mov si, word [bp-001e6h]                  ; 8b b6 1a fe
     cmp si, 00fffh                            ; 81 fe ff 0f
-    jne short 0214bh                          ; 75 10
+    jne short 02160h                          ; 75 10
     cmp ax, strict word 0ffffh                ; 3d ff ff
-    jne short 0214bh                          ; 75 0b
+    jne short 02160h                          ; 75 0b
     mov ax, word [bp-00198h]                  ; 8b 86 68 fe
     mov word [bp-020h], ax                    ; 89 46 e0
